Magellan Linux

Annotation of /tags/grubby-8_36/new-kernel-pkg

Parent Directory Parent Directory | Revision Log Revision Log


Revision 2259 - (hide annotations) (download)
Mon Oct 21 14:03:18 2013 UTC (10 years, 6 months ago) by niro
Original Path: trunk/grubby/new-kernel-pkg
File size: 23036 byte(s)
update extlinux.conf on arm arches if it exists
1 niro 532 #!/bin/bash
2 niro 924 # $Id$
3 niro 532 #
4 niro 923 # new-kernel-pkg
5 niro 532 # Invoked upon installation or removal of a kernel package, the following
6     # tasks are/can be done here:
7     # creation/removal of initrd
8     # run of depmod/removal of depmod generated files
9     # addition/removal of kernel images from grub/lilo configuration (via grubby)
10     #
11 niro 923 # Copyright 2002-2008 Red Hat, Inc. All rights reserved.
12 niro 532 # modified for Magellan-Linux by Niels Rogalla <niro@magellan-linux.de>
13     #
14 niro 923 # This program is free software; you can redistribute it and/or modify
15     # it under the terms of the GNU General Public License as published by
16     # the Free Software Foundation; either version 2 of the License, or
17     # (at your option) any later version.
18     #
19     # This program is distributed in the hope that it will be useful,
20     # but WITHOUT ANY WARRANTY; without even the implied warranty of
21     # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
22     # GNU General Public License for more details.
23     #
24     # You should have received a copy of the GNU General Public License
25     # along with this program. If not, see <http://www.gnu.org/licenses/>.
26     #
27 niro 532
28 niro 1778 read_os_release()
29     {
30     local NAME
31     local ID
32     local Version
33     local Version_ID
34     local PRETTY_NAME
35     local ANSI_COLOR
36     local CPE_NAME
37    
38     if [[ -f /etc/os-release ]]
39     then
40     source /etc/os-release
41    
42     case $1 in
43     name) echo "${NAME}" ;;
44     id) echo "${ID}" ;;
45     version) echo "${Version}" ;;
46     version_id) echo "${Version_ID}" ;;
47     pretty_name) echo "${PRETTY_NAME}" ;;
48     ansi_color) echo "${ANSI_COLOR}" ;;
49     cpe_name) echo "${CPE_NAME}" ;;
50     esac
51     fi
52     }
53    
54 niro 532 PATH=/sbin:/bin:$PATH
55    
56     lilo=/sbin/lilo
57    
58     # some defaults that are sane for most arches
59     kernelName=kernel
60    
61 niro 924 if [ -x ./grubby ]
62     then
63     grubby=./grubby
64 niro 532 else
65 niro 924 grubby=/sbin/grubby
66 niro 532 fi
67    
68 niro 925 [ -f /etc/conf.d/grubby ] && . /etc/conf.d/grubby
69 niro 1691 [ -f /etc/conf.d/grubby-uboot ] && . /etc/conf.d/grubby-uboot
70 niro 532
71 niro 1697 cfgGrub2=""
72     cfgGrub2Efi=""
73 niro 532 cfgGrub=""
74     cfgLilo=""
75 niro 1716 cfgExtlinux=""
76 niro 1691 cfguBoot=""
77 niro 532 runLilo=""
78     grubConfig=""
79 niro 1702 grub2Config=""
80     grub2EfiConfig=""
81 niro 1716 extlinuxConfig=""
82 niro 532
83     ARCH=$(uname -m)
84    
85 niro 924 if [[ ${ARCH} = ia64 ]]
86     then
87     liloConfig=/boot/efi/EFI/redhat/elilo.conf
88     bootPrefix=/boot/efi/EFI/redhat
89     liloFlag=elilo
90     isx86=""
91     elif [[ ${ARCH} = ppc64 ]] || [[ ${ARCH} = ppc ]]
92     then
93     liloConfig=/etc/yaboot.conf
94 niro 1803 grub2Config=/boot/grub/grub.cfg
95 niro 924 bootPrefix=/boot
96     lilo=/sbin/ybin
97     liloFlag=yaboot
98     runLilo="yes"
99     isx86=""
100     elif [[ ${ARCH} = sparc ]] || [[ ${ARCH} = sparc64 ]]
101     then
102     liloConfig=/etc/silo.conf
103     bootPrefix=/boot
104     liloFlag=silo
105     lilo=/sbin/silo
106     isx86=""
107     elif [[ ${ARCH} = s390 ]] || [[ ${ARCH} = s390x ]]
108     then
109     liloConfig=/etc/zipl.conf
110     bootPrefix=/boot
111     liloFlag=zipl
112     lilo=/sbin/zipl
113     runLilo="yes"
114     isx86=""
115 niro 1848 elif [[ ${ARCH} =~ armv[5|7].*l ]]
116 niro 1691 then
117     liloConfig=""
118     bootPrefix=/boot
119 niro 2259 extlinuxConfig=$(readlink -f /etc/extlinux.conf 2>/dev/null)
120 niro 1847 ubootDir=${UBOOT_DIR:-"/boot"}
121 niro 1691 ubootScript=$ubootDir/${UBOOT_SCR:-"boot.scr"}
122     ubootKList=${UBOOT_KLIST:-"klist.txt"}
123     ubootDevice=/dev/${UBOOT_DEVICE:-"mmcblk0p1"}
124     ubootDefaultImage=${UBOOT_UIMAGE:-"uImage"}
125     ubootDefaultInitrd=${UBOOT_UINITRD:-"uInitrd"}
126 niro 1937 ubootAddress=${UBOOT_IMGADDR:-"0x00008000"}
127 niro 1691 mounted=""
128     liloFlag=""
129     isx86=""
130 niro 532 else
131 niro 924 # this leaves i?86 and x86_64
132     liloConfig=/etc/lilo.conf
133     grubConfig=/boot/grub/grub.conf
134 niro 1697 grub2Config=/boot/grub/grub.cfg
135     grub2EfiConfig=/boot/grub/grub-efi.cfg
136 niro 1716 extlinuxConfig=/boot/extlinux/extlinux.conf
137 niro 924 bootPrefix=/boot
138     liloFlag=lilo
139     isx86="yes"
140 niro 532 fi
141    
142     mode=""
143     version=""
144     initrd=""
145 niro 1334 dracut=""
146     dracuthostonly=""
147 niro 532 initrdfile=""
148     moddep=""
149     verbose=""
150     makedefault=""
151     package=""
152 niro 1706 mbkernel="${HYPERVISOR}"
153     mbargs="${HYPERVISOR_ARGS}"
154 niro 1334 adddracutargs=""
155     addplymouthinitrd=""
156 niro 532
157 niro 924 usage()
158     {
159 niro 1334 echo "Usage: $(basename $0) [-v] [--mkinitrd] [--rminitrd] [--dracut]" >&2
160 niro 924 echo " [--initrdfile=<initrd-image>] [--depmod] [--rmmoddep]" >&2
161 niro 1305 echo " [--kernel-args=<args>] [--remove-args=<args>]" >&2
162 niro 924 echo " [--banner=<banner>] [--multiboot=multiboot]" >&2
163 niro 1334 echo " [--mbargs=mbargs] [--make-default] [--add-dracut-args]" >&2
164     echo " [--add-plymouth-initrd]" >&2
165     echo " [--host-only]" >&2
166 niro 924 echo " <--install | --remove | --update> <kernel-version>" >&2
167     echo " (ex: $(basename $0) --mkinitrd --depmod --install 2.4.7-2)" >&2
168     exit 1
169 niro 532 }
170    
171 niro 924 install()
172     {
173     # XXX kernel should be able to be specified also (or work right on ia64)
174 niro 2241 if [ ! -f ${kernelImage} ]
175 niro 924 then
176     [[ -n ${verbose} ]] && echo "kernel for ${version} does not exist, not running grubby"
177     return
178     fi
179 niro 923
180 niro 924 INITRD=""
181     if [ -f ${initrdfile} ]
182     then
183     [[ -n ${verbose} ]] && echo "found ${initrdfile} and using it with grubby"
184     INITRD="--initrd ${initrdfile}"
185 niro 1334
186     if [[ -n ${addplymouthinitrd} ]]
187     then
188     INITRD="${INITRD} --extra-initrd ${bootPrefix}/initrd-plymouth.img"
189     fi
190 niro 924 fi
191 niro 532
192 niro 924 # FIXME: is this a good heuristic to find out if we're on iSeries?
193     if [ -d /proc/iSeries ]
194     then
195     [[ -n ${verbose} ]] && echo "On an iSeries, just making img file"
196     if [[ -z ${initrdfile} ]]
197     then
198     [[ -n ${verbose} ]] && echo "No initrd, just adding system map"
199 niro 2241 /sbin/addSystemMap ${bootPrefix}/System.map-${version} ${kernelImage} ${bootPrefix}/vmlinitrd-${version}
200 niro 924 else
201 niro 2241 /sbin/addSystemMap ${bootPrefix}/System.map-${version} ${kernelImage} ${bootPrefix}/vmlinux.sm-${version}
202 niro 924 /sbin/addRamDisk ${initrdfile} ${bootPrefix}/System.map-${version} ${bootPrefix}/vmlinux.sm-${version} ${bootPrefix}/vmlinitrd-${version} 2>/dev/null
203     rm ${bootPrefix}/vmlinux.sm-${version}
204     fi
205     return
206 niro 532 fi
207    
208 niro 924 # get the root filesystem to use
209 niro 2238 rootdevice=$(awk '{ if ($1 !~ /^[ \t]*#/ && $2 == "/") { print $1; }}' /etc/fstab 2>/dev/null)
210 niro 2237 if [[ -z $rootdevice ]]
211     then
212     rootdevice=$(grep -o -P "(?<=root=)\S+" /proc/cmdline)
213     fi
214 niro 532
215 niro 924 if [[ -n ${mbkernel} ]] && [[ -n ${cfgLilo} ]] && [[ ${liloFlag} != elilo ]]
216     then
217     [[ -n ${verbose} ]] && echo "multiboot specified, not updating lilo.conf"
218     cfgLilo=""
219     fi
220 niro 532
221 niro 2239 if [[ -n ${banner} ]]
222     then
223     title="${banner} [ ${version} ]"
224     elif [[ $(read_os_release id) = magellan ]]
225     then
226     title="$(read_os_release name) $(read_os_release version_id) [ ${version} ]"
227     elif [ -f /etc/mageversion ]
228     then
229     title="Magellan Linux $(< /etc/mageversion) [ ${version} ]"
230     else
231     title="Magellan Linux [ ${version} ]"
232     fi
233    
234 niro 924 if [[ -n ${cfgGrub} ]]
235     then
236     [[ -n ${verbose} ]] && echo "adding ${version} to ${grubConfig}"
237 niro 532
238 niro 1710 ${grubby} --grub -c ${grubConfig} \
239 niro 2241 --add-kernel=${kernelImage} \
240 niro 924 ${INITRD} --copy-default ${makedefault} --title "${title}" \
241     ${mbkernel:+--add-multiboot="${mbkernel}"} ${mbargs:+--mbargs="${mbargs}"} \
242     --args="root=${rootdevice} ${kernargs}" --remove-kernel="TITLE=${title}"
243 niro 532 else
244 niro 1697 [[ -n ${verbose} ]] && echo "${grubConfig} does not exist, not running grubby for grub 0.97"
245 niro 532 fi
246 niro 1697 if [[ -n ${cfgGrub2} ]]
247     then
248     [[ -n ${verbose} ]] && echo "adding ${version} to ${grub2Config}"
249 niro 532
250 niro 1702 ${grubby} --grub2 -c ${grub2Config} \
251 niro 2241 --add-kernel=${kernelImage} \
252 niro 1697 ${INITRD} --copy-default ${makedefault} --title "${title}" \
253     ${mbkernel:+--add-multiboot="${mbkernel}"} \
254     ${mbargs:+--mbargs="${mbargs}"} \
255     --args="root=${rootdevice} ${kernargs}" --remove-kernel="TITLE=${title}"
256     else
257     [[ -n ${verbose} ]] && echo "${grub2Config} does not exist, not running grubby for grub 2"
258     fi
259     if [[ -n ${cfgGrub2Efi} ]]
260     then
261     [[ -n ${verbose} ]] && echo "adding ${version} to ${grub2EfiConfig}"
262    
263 niro 1940 ${grubby} --grub2 -c ${grub2EfiConfig} --efi \
264 niro 2241 --add-kernel=${kernelImage} \
265 niro 1697 ${INITRD} --copy-default ${makedefault} --title "${title}" \
266     ${mbkernel:+--add-multiboot="${mbkernel}"} \
267     ${mbargs:+--mbargs="${mbargs}"} \
268     --args="root=${rootdevice} ${kernargs}" --remove-kernel="TITLE=${title}"
269     else
270     [[ -n ${verbose} ]] && echo "${grub2EfiConfig} does not exist, not running grubby for grub 2 with UEFI"
271     fi
272    
273 niro 924 if [[ -n ${cfgLilo} ]]
274     then
275     [[ -n ${verbose} ]] && echo "adding ${version} to ${liloConfig}"
276 niro 532
277 niro 2241 ${grubby} --add-kernel=${kernelImage} ${INITRD} \
278 niro 924 --copy-default ${makedefault} --title ${version} \
279     ${mbkernel:+--add-multiboot="${mbkernel}"} ${mbargs:+--mbargs="${mbargs}"} \
280     --args="root=${rootdevice} ${kernargs}" --remove-kernel="TITLE=${version}" \
281     --${liloFlag}
282 niro 532
283 niro 924 if [[ -n ${runLilo} ]]
284     then
285     [[ -n ${verbose} ]] && echo "running ${lilo}"
286 niro 1305 if [ ! -x ${lilo} ]
287 niro 924 then
288     [[ -n ${verbose} ]] && echo "${lilo} does not exist"
289     else
290     ${lilo} > /dev/null
291     fi
292     fi
293     else
294     [[ -n ${verbose} ]] && echo "${liloConfig} does not exist, not running grubby"
295 niro 532 fi
296 niro 1716
297     if [[ -n ${cfgExtlinux} ]]
298     then
299     [[ -n ${verbose} ]] && echo "adding ${version} to ${extlinuxConfig}"
300    
301     ${grubby} --extlinux -c ${extlinuxConfig} \
302 niro 2241 --add-kernel=${kernelImage} \
303 niro 1716 ${INITRD} --copy-default ${makedefault} --title "${title}" \
304     ${mbkernel:+--add-multiboot="${mbkernel}"} ${mbargs:+--mbargs="${mbargs}"} \
305     --args="root=${rootdevice} ${kernargs}" --remove-kernel="TITLE=${title}"
306     else
307     [[ -n ${verbose} ]] && echo "${extlinuxConfig} does not exist, not running grubby for extlinux"
308     fi
309 niro 532 }
310    
311 niro 924 remove()
312     {
313     # FIXME: is this a good heuristic to find out if we're on iSeries?
314     if [ -d /proc/iSeries ]
315     then
316     [[ -n ${verbose} ]] && echo "On an iSeries, remove img file"
317 niro 2241 rm -f ${kernelImage}.img 2>/dev/null
318 niro 924 return
319     fi
320 niro 532
321 niro 924 if [[ -n ${cfgGrub} ]]
322     then
323     [[ -n ${verbose} ]] && echo "removing ${version} from ${grubConfig}"
324 niro 1710 ${grubby} --grub -c ${grubConfig} \
325 niro 2241 --remove-kernel=${kernelImage}
326 niro 924 else
327 niro 1697 [[ -n ${verbose} ]] && echo "${grubConfig} does not exist, not running grubby for grub 0.97"
328 niro 924 fi
329 niro 1697 if [[ -n ${cfgGrub2} ]]
330     then
331     [[ -n ${verbose} ]] && echo "removing ${version} from ${grub2Config}"
332     ${grubby} --grub2 -c ${grub2Config} \
333 niro 2241 --remove-kernel=${kernelImage}
334 niro 1697 else
335     [[ -n ${verbose} ]] && echo "${grub2Config} does not exist, not running grubby for grub 2"
336     fi
337     if [[ -n ${cfgGrub2Efi} ]]
338     then
339     [[ -n ${verbose} ]] && echo "removing ${version} from ${grub2EfiConfig}"
340 niro 2051 ${grubby} --grub2 -c ${grub2EfiConfig} --efi \
341 niro 2241 --remove-kernel=${kernelImage}
342 niro 1697 else
343     [[ -n ${verbose} ]] && echo "${grub2EfiConfig} does not exist, not running grubby grub 2 with UEFI"
344     fi
345 niro 532
346 niro 924 if [[ -n ${cfgLilo} ]]
347     then
348     [[ -n ${verbose} ]] && echo "removing ${version} from ${liloConfig}"
349 niro 2241 ${grubby} --remove-kernel=${kernelImage} --${liloFlag}
350 niro 532
351 niro 924 if [[ -n ${runLilo} ]]
352     then
353     [[ -n ${verbose} ]] && echo "running ${lilo}"
354     if [ ! -x ${lilo} ]
355     then
356     [[ -n ${verbose} ]] && echo "${lilo} does not exist"
357     else
358     ${lilo} > /dev/null
359     fi
360     fi
361     else
362     [[ -n ${verbose} ]] && echo "${liloConfig} does not exist, not running grubby"
363 niro 532 fi
364 niro 1691
365     if [[ -n ${cfguBoot} ]]
366     then
367     [[ -n ${verbose} ]] && echo "removing ${version} from ${ubootDir}..."
368    
369     if [ -f ${ubootDir}/${ubootKList} ]
370     then
371     tmpKList=$(mktemp ${ubootDir}/${ubootKList}.XXXX)
372     curversion=$(tail -n1 ${ubootDir}/${ubootKList})
373 niro 1847 sed "/$version$/d" ${ubootDir}/${ubootKList} > ${tmpKList}
374 niro 1691 newversion=$(tail -n1 ${tmpKList})
375     if [ -f ${ubootDir}/uImage-${newversion} ] && [ -f ${ubootDir}/uInitrd-${newversion} ]
376     then
377     if [[ ${curversion} != ${newversion} ]]
378     then
379     cp -fp ${ubootDir}/uImage-${newversion} ${ubootDir}/${ubootDefaultImage}
380     if [ $? -ne 0 ]
381     then
382     [[ -n ${verbose} ]] && echo "copy uImage-${newversion} error, default kernel not replaced!" && exit
383     fi
384     cp -fp ${ubootDir}/uInitrd-${newversion} ${ubootDir}/${ubootDefaultInitrd}
385     if [ $? -ne 0 ]
386     then
387     [[ -n ${verbose} ]] && echo "copy uInitrd-${newversion} error, default Initrd not replaced!" && exit
388     fi
389     fi
390    
391     [[ -n ${verbose} ]] && echo "removing uImage-${version}"
392     if [ -f ${ubootDir}/uImage-${version} ]
393     then
394     rm -f ${ubootDir}/uImage-${version}
395     else
396     [[ -n ${verbose} ]] && echo "uImage-${version} did not exist!"
397     fi
398    
399     [[ -n ${verbose} ]] && echo "removing uInitrd-${version}"
400     if [ -f ${ubootDir}/uInitrd-${version} ]
401     then
402     rm -f ${ubootDir}/uInitrd-${version}
403     else
404     [[ -n ${verbose} ]] && echo "uInitrd-${version} did not exist!"
405     fi
406    
407     mv ${tmpKList} ${ubootDir}/${ubootKList}
408 niro 2248 [ -x /sbin/a-b-c ] && /sbin/a-b-c
409 niro 1691 else
410     [[ -n ${verbose} ]] && echo "uImage ${newversion} does not exist!"
411     [ -f ${tmpKList} ] && rm -f ${tmpKList}
412     fi
413     else
414 niro 1752 [[ -n ${verbose} ]] && echo "No previous kernel version. U-Boot images not removed!"
415 niro 1691 fi
416     else
417     [[ -n ${verbose} ]] && echo "${ubootScript} does not exist, not modifying ${ubootDir}"
418     fi
419 niro 1716
420     if [[ -n ${cfgExtlinux} ]]
421     then
422     [[ -n ${verbose} ]] && echo "removing ${version} from ${extlinuxConfig}"
423     ${grubby} --extlinux -c ${extlinuxConfig} \
424 niro 2241 --remove-kernel=${kernelImage}
425 niro 1716 else
426     [[ -n ${verbose} ]] && echo "${extlinuxConfig} does not exist, not running grubby for extlinux"
427     fi
428 niro 532 }
429    
430 niro 924 update()
431     {
432 niro 2241 if [ ! -f ${kernelImage} ]
433 niro 1305 then
434     [[ -n ${verbose} ]] && echo "kernel for ${version} does not exist, not running grubby"
435     return
436     fi
437    
438     INITRD=""
439     if [ -f ${initrdfile} ]
440     then
441     [[ -n ${verbose} ]] && echo "found ${initrdfile} and using it with grubby"
442     INITRD="--initrd ${initrdfile}"
443 niro 1334
444     if [[ -n ${addplymouthinitrd} ]]
445     then
446     INITRD="${INITRD} --extra-initrd ${bootPrefix}/initrd-plymouth.img"
447     fi
448 niro 1305 fi
449    
450 niro 924 if [[ -n ${cfgGrub} ]]
451     then
452     [[ -n ${verbose} ]] && echo "updating ${version} from ${grubConfig}"
453 niro 1710 ${grubby} --grub -c ${grubConfig} \
454 niro 2241 --update-kernel=${kernelImage} \
455 niro 1305 ${INITRD} \
456 niro 924 ${kernargs:+--args="${kernargs}"} \
457     ${removeargs:+--remove-args="${removeargs}"}
458     else
459     [[ -n ${verbose} ]] && echo "${grubConfig} does not exist, not running grubby"
460     fi
461 niro 923
462 niro 1697 if [[ -n ${cfgGrub2} ]]
463     then
464     [[ -n ${verbose} ]] && echo "updating ${version} from ${grub2Config}"
465     ${grubby} --grub2 -c ${grub2Config} \
466 niro 2241 --update-kernel=${kernelImage} \
467 niro 1697 ${INITRD} \
468     ${kernargs:+--args="${kernargs}"} \
469     ${removeargs:+--remove-args="${removeargs}"}
470     else
471     [[ -n ${verbose} ]] && echo "${grub2Config} does not exist, not running grubby"
472     fi
473    
474     if [[ -n ${cfgGrub2Efi} ]]
475     then
476     [[ -n ${verbose} ]] && echo "updating ${version} from ${grub2EfiConfig}"
477 niro 2051 ${grubby} --grub2 -c ${grub2EfiConfig} --efi \
478 niro 2241 --update-kernel=${kernelImage} \
479 niro 1697 ${INITRD} \
480     ${kernargs:+--args="${kernargs}"} \
481     ${removeargs:+--remove-args="${removeargs}"}
482     else
483     [[ -n ${verbose} ]] && echo "${grub2EfiConfig} does not exist, not running grubby"
484     fi
485    
486 niro 924 if [[ -n ${cfgLilo} ]]
487     then
488     [[ -n ${verbose} ]] && echo "updating ${version} from ${liloConfig}"
489 niro 2241 ${grubby} --update-kernel=${kernelImage} \
490 niro 1305 ${INITRD} \
491 niro 924 ${kernargs:+--args="${kernargs}"} \
492     ${removeargs:+--remove-args="${removeargs}"} \
493     --${liloFlag}
494 niro 923
495 niro 924 if [[ -n ${runLilo} ]]
496     then
497     [[ -n ${verbose} ]] && echo "running ${lilo}"
498     if [ ! -x ${lilo} ]
499     then
500     [[ -n ${verbose} ]] && echo "${lilo} does not exist"
501     else
502     ${lilo} > /dev/null
503     fi
504     fi
505     else
506     [[ -n ${verbose} ]] && echo "${liloConfig} does not exist, not running grubby"
507 niro 923 fi
508 niro 1691
509     if [[ -n ${cfguBoot} ]]
510     then
511     [[ -n ${verbose} ]] && echo "adding $version to ${ubootDir}..."
512    
513     [[ -n ${verbose} ]] && echo "creating uImage-${version}"
514 niro 1752 mkimage -A arm -O linux -T kernel -C none -a ${ubootAddress} \
515     -e ${ubootAddress} -n ${version} \
516 niro 2241 -d ${kernelImage} ${ubootDir}/uImage-${version}
517 niro 1691
518     [[ -n ${verbose} ]] && echo "creating uInitrd-${version}"
519     mkimage -A arm -O linux -T ramdisk -C none -a 0 -e 0 \
520     -n initramfs -d ${initrdfile} ${ubootDir}/uInitrd-${version}
521    
522     if [ -f ${ubootDir}/uImage-${version} ] && [ -f ${ubootDir}/uInitrd-${version} ]
523     then
524     cp -fp ${ubootDir}/uImage-${version} ${ubootDir}/${ubootDefaultImage}
525     if [ $? -ne 0 ]
526     then
527     [[ -n ${verbose} ]] && echo "copy uImage-${version} error, kernel not installed!" && exit
528     fi
529     cp -fp ${ubootDir}/uInitrd-${version} ${ubootDir}/${ubootDefaultInitrd}
530     if [ $? -ne 0 ]
531     then
532     [[ -n ${verbose} ]] && echo "copy uInitrd-${version} error, kernel not installed!" && exit
533     fi
534     echo ${version} >> ${ubootDir}/${ubootKList}
535 niro 2248 [ -x /sbin/a-b-c ] && /sbin/a-b-c
536 niro 1691 else
537     [[ -n ${verbose} ]] && echo "cannot make ${version} the default"
538     fi
539     else
540     [[ -n ${verbose} ]] && echo "${ubootScript} does not exist, not setting up ${ubootDir}"
541     fi
542 niro 1716
543     if [[ -n ${cfgExtlinux} ]]
544     then
545     [[ -n ${verbose} ]] && echo "updating ${version} from ${extlinuxConfig}"
546     ${grubby} --extlinux -c ${extlinuxConfig} \
547 niro 2241 --update-kernel=${kernelImage} \
548 niro 1716 ${INITRD} \
549     ${kernargs:+--args="${kernargs}"} \
550     ${removeargs:+--remove-args="${removeargs}"}
551     else
552     [[ -n ${verbose} ]] && echo "${extlinuxConfig} does not exist, not running grubby"
553     fi
554 niro 923 }
555    
556 niro 1756 makeinitrd()
557 niro 924 {
558 niro 1334 if [[ -n ${dracut} ]]
559     then
560 niro 1728 tool="dracut ${dracuthostonly} -f ${initrdfile} ${version}"
561 niro 1334 else
562 niro 1749 tool="mkinitrd --allow-missing -f ${initrdfile} ${version}"
563 niro 1334 fi
564 niro 924 [[ -n ${verbose} ]] && echo "creating initrd ${initrdfile} using ${version}"
565 niro 1334 ${tool}
566 niro 924 rc=$?
567     if [ ${rc} != 0 ]
568     then
569     echo "mkinitrd failed" >&2
570     exit 1
571     fi
572 niro 532 }
573    
574 niro 924 rminitrd()
575     {
576     [[ -n ${verbose} ]] && echo "removing initrd ${initrdfile}"
577     [ -f ${initrdfile} ] && rm -f ${initrdfile}
578 niro 532 }
579    
580 niro 924 doDepmod()
581     {
582     [[ -n ${verbose} ]] && echo "running depmod for ${version}"
583     depmod -ae -F /boot/System.map-${version} ${version}
584 niro 532 }
585    
586 niro 924 doRmmoddep()
587     {
588     [[ -n ${verbose} ]] && echo "removing modules.dep info for ${version}"
589 niro 2242 if [ -d /lib/modules/${version} ]
590     then
591     rm -f /lib/modules/${version}/modules.*.bin \
592 niro 2244 /lib/modules/${version}/modules.{alias,dep,devname,symbols,softdep}
593 niro 2242 fi
594 niro 532 }
595    
596    
597 niro 924 while [ $# -gt 0 ]
598     do
599     case $1 in
600     --mkinitrd)
601     initrd="make"
602     ;;
603 niro 532
604 niro 924 --rminitrd)
605     initrd="remove"
606     ;;
607 niro 532
608 niro 1334 --dracut)
609     dracut=--dracut
610     ;;
611    
612     --host-only)
613     dracuthostonly=-H
614     ;;
615    
616 niro 924 --initrdfile*)
617 niro 2240 if [[ $1 == --initrdfile\=* ]]
618 niro 924 then
619 niro 2240 initrdfile=${1#--initrdfile=}
620 niro 924 else
621     initrdfile=$2
622     shift
623     fi
624     ;;
625 niro 532
626 niro 924 --kernel-args*)
627 niro 2240 if [[ $1 == --kernel-args\=* ]]
628 niro 924 then
629 niro 2240 kernargs=${1#--kernel-args=}
630 niro 924 else
631     kernargs=$2
632     shift
633     fi
634     ;;
635 niro 532
636 niro 924 --remove-args*)
637 niro 2240 if [[ $1 == --remove-args\=* ]]
638 niro 924 then
639 niro 2240 removeargs=${1#--remove-args=}
640 niro 924 else
641     removeargs=$2
642     shift
643     fi
644     ;;
645 niro 923
646 niro 924 --banner*)
647 niro 2240 if [[ $1 == --banner\=* ]]
648 niro 924 then
649 niro 2240 banner=${1#--banner=}
650 niro 924 else
651     banner=$2
652     shift
653     fi
654     ;;
655 niro 532
656 niro 924 --multiboot*)
657 niro 2240 if [[ $1 == --multiboot\=* ]]
658 niro 924 then
659 niro 2240 mbkernel=${1#--multiboot=}
660 niro 924 else
661     # can't really support having an optional second arg here
662     # sorry!
663     mbkernel="/boot/xen.gz"
664     fi
665     ;;
666 niro 532
667 niro 924 --mbargs*)
668 niro 2240 if [[ $1 == --mbargs\=* ]]
669 niro 924 then
670 niro 2240 mbargs=${1#--mbargs=}
671 niro 924 else
672     mbargs="$2"
673     shift
674     fi
675     ;;
676 niro 532
677 niro 924 --depmod)
678     moddep="make"
679     ;;
680 niro 532
681 niro 924 --rmmoddep)
682     moddep="remove"
683     ;;
684 niro 532
685 niro 924 --make-default)
686     makedefault="--make-default"
687     ;;
688 niro 532
689 niro 2240 --package*)
690     if [[ $1 == --package\=* ]]
691 niro 924 then
692 niro 2240 package=${1#--package=}
693 niro 924 else
694     package=$2
695     shift
696     fi
697     ;;
698 niro 532
699 niro 1334 --add-dracut-args)
700     adddracutargs=--add-dracut-args
701     ;;
702    
703     --add-plymouth-initrd)
704     addplymouthinitrd=--add-plymouth-initrd
705     ;;
706    
707 niro 2241 --kernel-image*)
708     if [[ $1 == --kernel-image\=* ]]
709     then
710     kernelImage=${1#--kernel-image=}
711     else
712     kernelImage="$2"
713     shift
714     fi
715     if ! [[ -f ${kernelImage} ]]
716     then
717     echo "Can't find kernel image '${kernelImage}'" >&2
718     usage
719     exit 1
720     fi
721     ;;
722    
723 niro 924 -v)
724     verbose=-v
725     ;;
726 niro 532
727 niro 924 *)
728     if [[ -z ${mode} ]]
729     then
730     mode=$1
731     elif [[ -z ${version} ]]
732     then
733     version=$1
734     else
735     usage
736     fi
737     ;;
738     esac
739 niro 532
740 niro 924 shift
741 niro 532 done
742    
743     # make sure the mode is valid
744 niro 924 if [[ ${mode} != --install ]] && [[ ${mode} != --remove ]] && [[ ${mode} != --update ]]
745     then
746     usage
747 niro 532 fi
748    
749 niro 924 if [[ -z ${version} ]]
750     then
751     usage
752 niro 532 fi
753    
754 niro 924 if [ "${mode}" != "--install" -a "${makedefault}" ]
755     then
756     usage
757 niro 532 fi
758    
759 niro 924 kernelmajor=$(echo ${kernel} | cut -d . -f 1,2)
760 niro 532
761 niro 1305 # kernel image for 2.4 is kernel
762 niro 924 if [[ ${ARCH} = ppc64 ]] || [[ ${ARCH} = ppc ]]
763     then
764     if [[ ${kernelmajor} = 2.4 ]]
765     then
766     kernelName=kernel
767     fi
768 niro 532 fi
769    
770 niro 2241 [[ ${kernelImage} ]] || kernelImage="${bootPrefix}/${kernelName}-${version}"
771    
772 niro 532 # set the initrd file based on arch; ia64 is the only currently known oddball
773 niro 924 if [[ -z ${initrdfile} ]]
774     then
775     INITRD_NAME_PREFIX="initrd"
776 niro 1334 if [[ -n ${dracut} ]]
777     then
778     INITRD_NAME_PREFIX="initramfs"
779     fi
780 niro 923
781 niro 924 if [[ $(uname -m) = ia64 ]]
782     then
783     initrdfile="/boot/efi/EFI/redhat/${INITRD_NAME_PREFIX}-${version}.img"
784     else
785     initrdfile="/boot/${INITRD_NAME_PREFIX}-${version}.img"
786     fi
787 niro 532 fi
788 niro 924 [[ -n ${verbose} ]] && echo "initrdfile is ${initrdfile}"
789 niro 532
790 niro 1334 # add dracut i18n, keyboard and plymouth kernel args if requested
791     if [[ -n ${dracut} ]] || [[ -n ${adddracutargs} ]]
792     then
793 niro 2059 if [ -r /etc/vconsole.conf ]
794     then
795     . /etc/vconsole.conf
796 niro 1334
797 niro 2059 for i in SYSFONT SYSFONTACM UNIMAP KEYTABLE
798     do
799     val=$(eval echo \$$i)
800     [[ -n ${val} ]] && kernargs="${kernargs} ${i}=${val}"
801     done
802     else
803     if [ -r /etc/conf.d/consolefont ]
804     then
805     . /etc/conf.d/consolefont
806    
807     if [[ -n ${CONSOLEFONT} ]]
808     then
809     kernargs="${kernargs} SYSFONT=${CONSOLEFONT}"
810     fi
811     fi
812    
813     if [ -r /etc/conf.d/keymap ]
814     then
815     . /etc/conf.d/keymap
816    
817     if [[ -n ${KEYMAP} ]]
818     then
819     kernargs="${kernargs} KEYTABLE=${KEYMAP}"
820     fi
821     fi
822 niro 1334 fi
823    
824 niro 2059 if [ -r /etc/locale.conf ]
825 niro 1334 then
826 niro 2059 . /etc/locale.conf
827    
828     if [[ -n ${LANG} ]]
829     then
830     kernargs="${kernargs} LANG=${LANG}"
831     fi
832 niro 1334 fi
833     fi
834    
835 niro 532 # set this as the default if we have the package and it matches
836 niro 924 if [[ ${mode} = --install ]] && [[ ${UPDATEDEFAULT} = yes ]] && [[ -n ${package} ]] &&
837     [[ -n ${DEFAULTKERNEL} ]] && [[ ${package} = ${DEFAULTKERNEL} ]]
838     then
839     makedefault="--make-default"
840     [[ -n ${verbose} ]] && echo "making it the default based on config"
841 niro 532 fi
842    
843 niro 924 if [[ ${moddep} = make ]]
844     then
845     doDepmod
846     elif [[ ${moddep} = remove ]]
847     then
848     doRmmoddep
849 niro 532 fi
850    
851 niro 924 if [[ ${initrd} = make ]]
852     then
853 niro 1756 makeinitrd
854 niro 924 elif [[ ${initrd} = remove ]]
855     then
856     rminitrd
857 niro 532 fi
858    
859 niro 924 if [ ! -x ${grubby} ]
860     then
861     [[ -n ${verbose} ]] && echo "${grubby} does not exist"
862     exit 0
863 niro 532 fi
864    
865 niro 924 [[ -n ${grubConfig} ]] && [ -f ${grubConfig} ] && cfgGrub=1
866 niro 1697 [[ -n ${grub2Config} ]] && [ -f ${grub2Config} ] && cfgGrub2=1
867     [[ -n ${grub2EfiConfig} ]] && [ -f ${grub2EfiConfig} ] && cfgGrub2Efi=1
868 niro 924 [[ -n ${liloConfig} ]] && [ -f ${liloConfig} ] && cfgLilo=1
869 niro 1716 [[ -n ${extlinuxConfig} ]] && [ -f ${extlinuxConfig} ] && cfgExtlinux=1
870 niro 532
871 niro 1752 # if we have a U-Boot directory, but no boot script, check if the directory
872     # is mounted. If not, mount it, and then check if a boot script exists.
873 niro 1691 if [[ -n ${ubootDir} ]]
874     then
875 niro 1752 if [ -f ${ubootScript} ]
876 niro 1691 then
877 niro 1752 cfguBoot=1
878     else
879     mountEntry=$(mount | grep ${ubootDir})
880     if [[ -z ${mountEntry} ]]
881     then
882     mount ${ubootDevice} ${ubootDir}
883     mounted=1
884     fi
885     [ -f ${ubootScript} ] && cfguBoot=1
886 niro 1691 fi
887     fi
888    
889 niro 1937 # if we're using U-Boot, check if the default load address should change
890     if [[ -n ${cfguBoot} ]] && [[ -z ${UBOOT_IMGADDR} ]]
891     then
892     [[ ${version} =~ .([^.]*)$ ]]
893     platform=${BASH_REMATCH[1]}
894     # A few platforms use an alternate kernel load address
895     if [[ ${platform} = omap ]]
896     then
897     ubootAddress=0x80008000
898     elif [[ ${platform} = imx ]]
899     then
900     ubootAddress=0x90008000
901     fi
902     fi
903    
904 niro 532 # if we have a lilo config on an x86 box, see if the default boot loader
905     # is lilo to determine if it should be run
906 niro 924 if [[ -n ${cfgLilo} ]] && [[ -n ${isx86} ]]
907     then
908     runLilo=$(${grubby} --bootloader-probe | grep lilo)
909 niro 532 fi
910    
911 niro 924 if [[ ${mode} = --install ]]
912     then
913     install
914     elif [[ ${mode} = --remove ]]
915     then
916     remove
917     elif [[ ${mode} = --update ]]
918     then
919     update
920 niro 532 fi
921    
922 niro 1752 # if we mounted the U-Boot directory, unmount it.
923     [[ -n ${mounted} ]] && umount ${ubootDir}
924    
925 niro 532 exit 0

Properties

Name Value
svn:executable *